Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Static Public Attributes | List of all members
ParticlePanel Class Reference
Inheritance diagram for ParticlePanel:

## Public Member Functions
| __init__ (self, particleEffect=None, **kw)
| addConstantInterpolationSegment (self, id=None)
| addForce (self, f)
| addForceGroupNotebookPage (self, particleEffect, forceGroup)
| addForceWidget (self, forceGroup, force)
| addLinearCylinderVortexForce (self)
| addLinearFrictionForce (self)
| addLinearInterpolationSegment (self, id=None)
| addLinearJitterForce (self)
| addLinearNoiseForce (self)
| addLinearSinkForce (self)
| addLinearSourceForce (self)
| addLinearUserDefinedForce (self)
| addLinearVectorForce (self)
| addRendererSpriteAnimationFromNode (self)
| addRendererSpriteAnimationTexture (self)
| addSinusoidInterpolationSegment (self, id=None)
| addStepwaveInterpolationSegment (self, id=None)
| appInit (self)
| USER METHODS ### To be overridden.
| createAngleDial (self, parent, category, text, balloonHelp, command=None, **kw)
| createCheckbutton (self, parent, category, text, balloonHelp, command, initialState, side='top')
| WIDGET UTILITY FUNCTIONS ###.
| createColorEntry (self, parent, category, text, balloonHelp, command=None, **kw)
| createComboBox (self, parent, category, text, balloonHelp, items, command, history=0)
| createConstantInterpolationSegmentWidget (self, parent, segName, segment)
| createFloater (self, parent, category, text, balloonHelp, command=None, min=0.0, max=None, resolution=None, numDigits=None, **kw)
| createFloaters (self, parent, widgetDefinitions)
| createForceActiveWidget (self, frame, pageName, forceName, force)
| createForceFrame (self, forcePage, forceName, force)
| createInterface (self)
| createInterpolationSegmentFrame (self, parent, segName, seg)
| createLinearCylinderVortexForceWidget (self, forcePage, pageName, count, force)
| createLinearDistanceForceWidget (self, forcePage, pageName, count, force, type)
| createLinearForceWidgets (self, frame, pageName, forceName, force)
| createLinearFrictionForceWidget (self, forcePage, pageName, count, force)
| createLinearInterpolationSegmentWidget (self, parent, segName, segment)
| createLinearRandomForceWidget (self, forcePage, pageName, count, force, type)
| createLinearVectorForceWidget (self, forcePage, pageName, count, force)
| createNewEffect (self)
| SYSTEM COMMANDS ##.
| createNewForceGroup (self)
| createNewParticles (self)
| createOptionMenu (self, parent, category, text, balloonHelp, items, command)
| createRadiobutton (self, parent, side, category, text, balloonHelp, variable, value, command)
| createSinusoidInterpolationSegmentWidget (self, parent, segName, segment)
| createSlider (self, parent, category, text, balloonHelp, command=None, min=0.0, max=1.0, resolution=0.001, **kw)
| createSpriteAnimationFrame (self, parent, anim, animName)
| createSpriteAnimationNodeWidget (self, parent, anim, animName)
| createSpriteAnimationTextureWidget (self, parent, anim, animName)
| createStepwaveInterpolationSegmentWidget (self, parent, segName, segment)
| createVector2Entry (self, parent, category, text, balloonHelp, command=None, **kw)
| createVector3Entry (self, parent, category, text, balloonHelp, command=None, **kw)
| createWidgetForExistingInterpolationSegment (self, id)
| getVariable (self, category, text)
| getWidget (self, category, text)
| loadParticleEffectFromFile (self)
| readSpriteRendererAnimations (self)
| rendererPointSelectBlendMethod (self, blendMethod)
| rendererPointSelectBlendType (self, blendType)
| saveParticleEffectToFile (self)
| selectEffectNamed (self, name)
| selectEmitterPage (self)
| selectEmitterType (self, type)
| EMITTER PAGE ##.
| selectFactoryPage (self)
| selectFactoryType (self, type)
| FACTORY PAGE ##.
| selectForceGroupNamed (self, name)
| selectParticlesNamed (self, name)
| selectRendererPage (self)
| selectRendererType (self, type)
| RENDERER PAGE ##.
| setEmissionType (self, newType=None)
| setEmitterAmplitude (self, value)
| setEmitterAmplitudeSpread (self, value)
| setEmitterBoxPoint1 (self, point)
| setEmitterBoxPoint2 (self, point)
| setEmitterDiscInnerAngle (self, angle)
| setEmitterDiscInnerVelocity (self, velocity)
| setEmitterDiscOuterAngle (self, angle)
| setEmitterDiscOuterVelocity (self, velocity)
| setEmitterDiscRadius (self, radius)
| setEmitterExplicitLaunchVector (self, vec)
| setEmitterLinePoint1 (self, point)
| setEmitterLinePoint2 (self, point)
| setEmitterOffsetForce (self, vec)
| setEmitterPointPosition (self, pos)
| setEmitterRadiateOrigin (self, origin)
| setEmitterRectanglePoint1 (self, point)
| setEmitterRectanglePoint2 (self, point)
| setEmitterRingLaunchAngle (self, angle)
| setEmitterRingRadius (self, radius)
| setEmitterRingRadiusSpread (self, radiusSpread)
| setEmitterSphereSurfaceRadius (self, radius)
| setEmitterSphereVolumeRadius (self, radius)
| setEmitterTangentRingRadius (self, radius)
| setEmitterTangentRingRadiusSpread (self, radiusSpread)
| setFactoryLifeSpan (self, value)
| setFactoryLifeSpanSpread (self, value)
| setFactoryParticleMass (self, value)
| setFactoryParticleMassSpread (self, value)
| setFactoryTerminalVelocity (self, value)
| setFactoryTerminalVelocitySpread (self, value)
| setFactoryZSpinAngularVelocity (self, vel)
| setFactoryZSpinAngularVelocitySpread (self, spread)
| setFactoryZSpinFinalAngle (self, angle)
| setFactoryZSpinFinalAngleSpread (self, spread)
| setFactoryZSpinInitialAngle (self, angle)
| setFactoryZSpinInitialAngleSpread (self, spread)
| setRendererAlphaMode (self, alphaMode)
| setRendererColorBlendAttrib (self, rendererName, blendMethodStr, incomingOperandStr, fbufferOperandStr)
| setRendererGeomColorBlendFbufferOperand (self, operand)
| setRendererGeomColorBlendIncomingOperand (self, operand)
| setRendererGeomColorBlendMethod (self, blendMethod)
| setRendererGeomFinalXScale (self, xScale)
| setRendererGeomFinalYScale (self, yScale)
| setRendererGeomFinalZScale (self, zScale)
| setRendererGeomInitialXScale (self, xScale)
| setRendererGeomInitialYScale (self, yScale)
| setRendererGeomInitialZScale (self, zScale)
| setRendererGeomNode (self, event)
| setRendererLineHeadColor (self, color)
| setRendererLineScaleFactor (self, sf)
| setRendererLineTailColor (self, color)
| setRendererPointEndColor (self, color)
| setRendererPointSize (self, size)
| setRendererPointStartColor (self, color)
| setRendererSparkleBirthRadius (self, radius)
| setRendererSparkleCenterColor (self, color)
| setRendererSparkleDeathRadius (self, radius)
| setRendererSparkleEdgeColor (self, color)
| setRendererSparkleLifeScale (self, lifeScaleMethod)
| setRendererSpriteAnimationEnable (self)
| setRendererSpriteAnimationFrameRate (self, rate)
| setRendererSpriteBlendMethod (self, blendMethod)
| setRendererSpriteColorBlendFbufferOperand (self, operand)
| setRendererSpriteColorBlendIncomingOperand (self, operand)
| setRendererSpriteColorBlendMethod (self, blendMethod)
| setRendererSpriteFinalXScale (self, xScale)
| setRendererSpriteFinalYScale (self, yScale)
| setRendererSpriteInitialXScale (self, xScale)
| setRendererSpriteInitialYScale (self, yScale)
| setRendererSpriteNonAnimatedTheta (self, theta)
| setRendererUserAlpha (self, alpha)
| setSpriteSourceType (self)
| setSystemBirthRate (self, value)
| setSystemHpr (self, pos)
| setSystemLifespan (self, value)
| setSystemLitterSize (self, value)
| setSystemLitterSpread (self, value)
| setSystemPoolSize (self, value)
| setSystemPos (self, pos)
| toggleAngularVelocity (self)
| toggleEffect (self, effect, var)
| toggleEmitterDiscCubicLerping (self)
| toggleForce (self, force, pageName, variableName)
| toggleForceGroup (self, forceGroup, var)
| toggleParticleEffect (self)
| toggleParticleMgr (self)
| PARTICLE EFFECTS COMMANDS ###.
| toggleParticles (self, particles, var)
| toggleRendererGeomXScale (self)
| toggleRendererGeomYScale (self)
| toggleRendererGeomZScale (self)
| toggleRendererSpriteAlphaDisable (self)
| toggleRendererSpriteAnimAngle (self)
| toggleRendererSpriteXScale (self)
| toggleRendererSpriteYScale (self)
| toggleSystemGrowsOlder (self)
| toggleSystemLocalVelocity (self)
| updateEffectsMenus (self)
| updateEmitterWidgets (self)
| updateFactoryWidgets (self)
| updateForceGroupMenus (self)
| updateForceWidgets (self)
| FORCEGROUP COMMANDS ##.
| updateInfo (self, page='System')
| PARTICLE SYSTEM COMMANDS ###.
| updateLabels (self)
| updateMenus (self)
| updateMenusAndLabels (self)
| updateParticlesMenus (self)
| updateRendererWidgets (self)
| updateSystemWidgets (self)
| SYSTEM PAGE ##.
| writeSpriteRendererAnimations (self)
Public Member Functions inherited from AppShell
| __init__ (self, parent=None, **kw)
| addVariable (self, category, text, variable)
| addWidget (self, category, text, widget)
| WIDGET UTILITY FUNCTIONS ##.
| alignbuttons (self)
| balloon (self)
| bind (self, child, balloonHelpMsg, statusHelpMsg=None)
| buttonAdd (self, buttonName, helpMessage=None, statusMessage=None, **kw)
| buttonBox (self)
| createMenuBar (self)
| createWidget (self, parent, category, text, widgetClass, help, command, side, fill, expand, kw)
| interior (self)
| messageBar (self)
| newCreateButton (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateCheckbutton (self, parent, category, text, help='', command=None, initialState=0, anchor=W, side=LEFT, fill=X, expand=0, **kw)
| newCreateColorEntry (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateComboBox (self, parent, category, text, help='', command=None, items=[], state=DISABLED, history=0, labelpos=W, label_anchor=W, label_width=16, entry_width=16, side=LEFT, fill=X, expand=0, **kw)
| newCreateDial (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateEntryScale (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateFloater (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateLabeledEntry (self, parent, category, text, help='', command=None, value='', width=12, relief=SUNKEN, side=LEFT, fill=X, expand=0)
| newCreateOptionMenu (self, parent, category, text, help='', command=None, items=[], labelpos=W, label_anchor=W, label_width=16, menu_tearoff=1, side=LEFT, fill=X, expand=0, **kw)
| newCreateRadiobutton (self, parent, category, text, variable, value, command=None, help='', anchor=W, side=LEFT, fill=X, expand=0, **kw)
| newCreateSider (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateVector2Entry (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateVector3Entry (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| onDestroy (self, event)
| quit (self)
| showAbout (self)
| toggleBalloon (self)
| transformRGB (self, rgb, max=1.0)
| updateProgress (self, newValue=0, newMax=0)
Public Member Functions inherited from DirectObject
| __init__ (self)
| accept (self, event, method, extraArgs=[])
| acceptOnce (self, event, method, extraArgs=[])
| addTask (self, *args, **kwargs)
| detectLeaks (self)
| doMethodLater (self, *args, **kwargs)
| getAllAccepting (self)
| ignore (self, event)
| ignoreAll (self)
| isAccepting (self, event)
| isIgnoring (self, event)
| removeAllTasks (self)
| removeTask (self, taskOrName)

## Public Attributes
dict | effectsDict = pe
| effectsEnableMenu = Menu(self.effectsLabelMenu, tearoff = 0)
| effectsLabel
| effectsLabelMenu = Menu(self.effectsLabel, tearoff = 0)
| emissionType = IntVar()
| EMITTER PAGE WIDGETS ##.
| emitterNotebook = Pmw.NoteBook(emitterPage, tabpos = None)
| factoryNotebook = Pmw.NoteBook(factoryPage, tabpos = None)
| forceGroup = forceGroupList[0]
| forceGroupEnableMenu = Menu(self.forceGroupLabelMenu, tearoff = 0)
| forceGroupLabel
| forceGroupLabelMenu = Menu(self.forceGroupLabel, tearoff = 0)
tuple | forcePageName
dict | forcePagesDict = {}
| mainNotebook = Pmw.NoteBook(interior)
| particleEffect = particleEffect
| particleMgrActive = IntVar()
| particles = self.particleEffect.getParticlesList()[0]
| particlesEnableMenu = Menu(self.particlesLabelMenu, tearoff = 0)
| particlesLabel
| particlesLabelMenu = Menu(self.particlesLabel, tearoff = 0)
| rendererGeomNode = StringVar()
| rendererGeomNodeEntry
| rendererGeomSegmentFrame = sf.interior()
| rendererNotebook = Pmw.NoteBook(rendererPage, tabpos = None)
| rendererPointSelectBlendMethod
| rendererPointSelectBlendType = self.setRendererPointEndColor)
| ringCustomFrame = Frame(ringPage)
| selectEmitterType = BOTH)
| EMITTER PAGE WIDGETS ##.
| selectFactoryType
| FACTORY PAGE WIDGETS ##.
| selectRendererType = X)
| RENDERER PAGE WIDGETS ##.
| setEmissionType
| setRendererAlphaMode
| RENDERER PAGE WIDGETS ##.
| setRendererGeomColorBlendFbufferOperand
| setRendererGeomColorBlendIncomingOperand
| setRendererGeomColorBlendMethod = X)
| setRendererGeomNode
| setRendererSparkleLifeScale = self.setRendererSparkleDeathRadius)
| toggleAngularVelocity = self.factoryNotebook.add('ZSpinParticleFactory')
| toggleEmitterDiscCubicLerping = self.setEmitterDiscOuterVelocity)
| toggleRendererGeomXScale = X)
| toggleRendererGeomYScale = LEFT)
| toggleRendererGeomZScale = LEFT)
| toggleSystemGrowsOlder
| toggleSystemLocalVelocity
Public Attributes inherited from AppShell
| about
| dataArea
str | id = self.appname + '-' + repr(AppShell.panelCount)
| menuBar
| menuFrame = Frame(self._hull)
| onDestroy
| parent = Toplevel()
| toggleBalloonVar = IntVar()
dict | variableDict = {}
dict | widgetDict = {}

## Static Public Attributes
| activebackground
| addForceButton
| FORCE PAGE WIDGETS ##.
| addSegmentButton
| bbp = Frame(bp)
| borderwidth
| BOTH
| bp = Frame(p)
| command
| expand
| fill
| font
| forceFrame
| forceGroupNotebook
| forceMenu = Menu(self.addForceButton)
dict | forcePage
| horizflex
| label
| p = Frame(rendererSpriteTexturePage)
| pp = Frame(p)
| relief
list | rendererSegmentWidgetList
| rendererSpriteAnimationFrame
list | rendererSpriteAnimationWidgetList
| rendererSpriteFile
| rendererSpriteNode
| rendererSpriteSegmentFrame
| rendererSpriteTexture
| segmentMenu = Menu(addSegmentButton)
| sf = Pmw.ScrolledFrame(pp, horizflex = 'elastic')
| side
| tabpos
| text
Static Public Attributes inherited from AppShell
str | appname = 'Generic Application Frame'
str | appversion = '1.0'
str | balloonState = 'none'
str | contactemail = 'Mark.Mine@disney.com'
str | contactname = 'Mark R. Mine'
str | contactphone = '(818) 544-2921'
tuple | copyright
int | frameHeight = 320
int | frameWidth = 450
int | padx = 5
int | pady = 5
int | panelCount = 0
int | usecommandarea = 0
int | usestatusarea = 0
Static Public Attributes inherited from DirectObject
| accept_once = acceptOnce
| add_task = addTask
| detect_leaks = detectLeaks
| do_method_later = doMethodLater
| get_all_accepting = getAllAccepting
| ignore_all = ignoreAll
| is_accepting = isAccepting
| is_ignoring = isIgnoring
| remove_all_tasks = removeAllTasks
| remove_task = removeTask

## Additional Inherited Members
Protected Member Functions inherited from DirectObject
| _addTask (self, task)
| _clearTask (self, task)
Protected Attributes inherited from AppShell
| _hull = self.component('hull')
Protected Attributes inherited from DirectObject
dict | _taskList = {}

## Constructor & Destructor Documentation

## ◆ __init__()

__init__ | ( |  | self,
|  |  | particleEffect = None,
|  | ** | kw )

## Member Function Documentation

## ◆ addConstantInterpolationSegment()

addConstantInterpolationSegment | ( |  | self,
|  |  | id = None )

## ◆ addForce()

addForce | ( |  | self,
|  |  | f )

## ◆ addForceGroupNotebookPage()

addForceGroupNotebookPage | ( |  | self,
|  |  | particleEffect,
|  |  | forceGroup )

## ◆ addForceWidget()

addForceWidget | ( |  | self,
|  |  | forceGroup,
|  |  | force )

## ◆ addLinearCylinderVortexForce()

addLinearCylinderVortexForce | ( |  | self | ) |

## ◆ addLinearFrictionForce()

addLinearFrictionForce | ( |  | self | ) |

## ◆ addLinearInterpolationSegment()

addLinearInterpolationSegment | ( |  | self,
|  |  | id = None )

## ◆ addLinearJitterForce()

addLinearJitterForce | ( |  | self | ) |

## ◆ addLinearNoiseForce()

addLinearNoiseForce | ( |  | self | ) |

## ◆ addLinearSinkForce()

addLinearSinkForce | ( |  | self | ) |

## ◆ addLinearSourceForce()

addLinearSourceForce | ( |  | self | ) |

## ◆ addLinearUserDefinedForce()

addLinearUserDefinedForce | ( |  | self | ) |

## ◆ addLinearVectorForce()

addLinearVectorForce | ( |  | self | ) |

## ◆ addRendererSpriteAnimationFromNode()

addRendererSpriteAnimationFromNode | ( |  | self | ) |

## ◆ addRendererSpriteAnimationTexture()

addRendererSpriteAnimationTexture | ( |  | self | ) |

## ◆ addSinusoidInterpolationSegment()

addSinusoidInterpolationSegment | ( |  | self,
|  |  | id = None )

## ◆ addStepwaveInterpolationSegment()

addStepwaveInterpolationSegment | ( |  | self,
|  |  | id = None )

## ◆ appInit()

appInit | ( |  | self | ) |

USER METHODS ### To be overridden.

Reimplemented from AppShell.

## ◆ createAngleDial()

createAngleDial | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createCheckbutton()

createCheckbutton | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command,
|  |  | initialState,
|  |  | side = 'top' )

WIDGET UTILITY FUNCTIONS ###.

## ◆ createColorEntry()

createColorEntry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createComboBox()

createComboBox | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | items,
|  |  | command,
|  |  | history = 0 )

## ◆ createConstantInterpolationSegmentWidget()

createConstantInterpolationSegmentWidget | ( |  | self,
|  |  | parent,
|  |  | segName,
|  |  | segment )

## ◆ createFloater()

createFloater | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  |  | min = 0.0,
|  |  | max = None,
|  |  | resolution = None,
|  |  | numDigits = None,
|  | ** | kw )

## ◆ createFloaters()

createFloaters | ( |  | self,
|  |  | parent,
|  |  | widgetDefinitions )

## ◆ createForceActiveWidget()

createForceActiveWidget | ( |  | self,
|  |  | frame,
|  |  | pageName,
|  |  | forceName,
|  |  | force )

## ◆ createForceFrame()

createForceFrame | ( |  | self,
|  |  | forcePage,
|  |  | forceName,
|  |  | force )

## ◆ createInterface()

createInterface | ( |  | self | ) |

Reimplemented from AppShell.

## ◆ createInterpolationSegmentFrame()

createInterpolationSegmentFrame | ( |  | self,
|  |  | parent,
|  |  | segName,
|  |  | seg )

## ◆ createLinearCylinderVortexForceWidget()

createLinearCylinderVortexForceWidget | ( |  | self,
|  |  | forcePage,
|  |  | pageName,
|  |  | count,
|  |  | force )

## ◆ createLinearDistanceForceWidget()

createLinearDistanceForceWidget | ( |  | self,
|  |  | forcePage,
|  |  | pageName,
|  |  | count,
|  |  | force,
|  |  | type )

## ◆ createLinearForceWidgets()

createLinearForceWidgets | ( |  | self,
|  |  | frame,
|  |  | pageName,
|  |  | forceName,
|  |  | force )

## ◆ createLinearFrictionForceWidget()

createLinearFrictionForceWidget | ( |  | self,
|  |  | forcePage,
|  |  | pageName,
|  |  | count,
|  |  | force )

## ◆ createLinearInterpolationSegmentWidget()

createLinearInterpolationSegmentWidget | ( |  | self,
|  |  | parent,
|  |  | segName,
|  |  | segment )

## ◆ createLinearRandomForceWidget()

createLinearRandomForceWidget | ( |  | self,
|  |  | forcePage,
|  |  | pageName,
|  |  | count,
|  |  | force,
|  |  | type )

## ◆ createLinearVectorForceWidget()

createLinearVectorForceWidget | ( |  | self,
|  |  | forcePage,
|  |  | pageName,
|  |  | count,
|  |  | force )

## ◆ createNewEffect()

createNewEffect | ( |  | self | ) |

SYSTEM COMMANDS ##.

## ◆ createNewForceGroup()

createNewForceGroup | ( |  | self | ) |

## ◆ createNewParticles()

createNewParticles | ( |  | self | ) |

## ◆ createOptionMenu()

createOptionMenu | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | items,
|  |  | command )

## ◆ createRadiobutton()

createRadiobutton | ( |  | self,
|  |  | parent,
|  |  | side,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | variable,
|  |  | value,
|  |  | command )

## ◆ createSinusoidInterpolationSegmentWidget()

createSinusoidInterpolationSegmentWidget | ( |  | self,
|  |  | parent,
|  |  | segName,
|  |  | segment )

## ◆ createSlider()

createSlider | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  |  | min = 0.0,
|  |  | max = 1.0,
|  |  | resolution = 0.001,
|  | ** | kw )

## ◆ createSpriteAnimationFrame()

createSpriteAnimationFrame | ( |  | self,
|  |  | parent,
|  |  | anim,
|  |  | animName )

## ◆ createSpriteAnimationNodeWidget()

createSpriteAnimationNodeWidget | ( |  | self,
|  |  | parent,
|  |  | anim,
|  |  | animName )

## ◆ createSpriteAnimationTextureWidget()

createSpriteAnimationTextureWidget | ( |  | self,
|  |  | parent,
|  |  | anim,
|  |  | animName )

## ◆ createStepwaveInterpolationSegmentWidget()

createStepwaveInterpolationSegmentWidget | ( |  | self,
|  |  | parent,
|  |  | segName,
|  |  | segment )

## ◆ createVector2Entry()

createVector2Entry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createVector3Entry()

createVector3Entry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createWidgetForExistingInterpolationSegment()

createWidgetForExistingInterpolationSegment | ( |  | self,
|  |  | id )

## ◆ getVariable()

getVariable | ( |  | self,
|  |  | category,
|  |  | text )

Reimplemented from AppShell.

## ◆ getWidget()

getWidget | ( |  | self,
|  |  | category,
|  |  | text )

Reimplemented from AppShell.

## ◆ loadParticleEffectFromFile()

loadParticleEffectFromFile | ( |  | self | ) |

## ◆ readSpriteRendererAnimations()

readSpriteRendererAnimations | ( |  | self | ) |

## ◆ rendererPointSelectBlendMethod()

rendererPointSelectBlendMethod | ( |  | self,
|  |  | blendMethod )

## ◆ rendererPointSelectBlendType()

rendererPointSelectBlendType | ( |  | self,
|  |  | blendType )

## ◆ saveParticleEffectToFile()

saveParticleEffectToFile | ( |  | self | ) |

## ◆ selectEffectNamed()

selectEffectNamed | ( |  | self,
|  |  | name )

## ◆ selectEmitterPage()

selectEmitterPage | ( |  | self | ) |

## ◆ selectEmitterType()

selectEmitterType | ( |  | self,
|  |  | type )

EMITTER PAGE ##.

## ◆ selectFactoryPage()

selectFactoryPage | ( |  | self | ) |

## ◆ selectFactoryType()

selectFactoryType | ( |  | self,
|  |  | type )

FACTORY PAGE ##.

## ◆ selectForceGroupNamed()

selectForceGroupNamed | ( |  | self,
|  |  | name )

## ◆ selectParticlesNamed()

selectParticlesNamed | ( |  | self,
|  |  | name )

## ◆ selectRendererPage()

selectRendererPage | ( |  | self | ) |

## ◆ selectRendererType()

selectRendererType | ( |  | self,
|  |  | type )

RENDERER PAGE ##.

## ◆ setEmissionType()

setEmissionType | ( |  | self,
|  |  | newType = None )

## ◆ setEmitterAmplitude()

setEmitterAmplitude | ( |  | self,
|  |  | value )

## ◆ setEmitterAmplitudeSpread()

setEmitterAmplitudeSpread | ( |  | self,
|  |  | value )

## ◆ setEmitterBoxPoint1()

setEmitterBoxPoint1 | ( |  | self,
|  |  | point )

## ◆ setEmitterBoxPoint2()

setEmitterBoxPoint2 | ( |  | self,
|  |  | point )

## ◆ setEmitterDiscInnerAngle()

setEmitterDiscInnerAngle | ( |  | self,
|  |  | angle )

## ◆ setEmitterDiscInnerVelocity()

setEmitterDiscInnerVelocity | ( |  | self,
|  |  | velocity )

## ◆ setEmitterDiscOuterAngle()

setEmitterDiscOuterAngle | ( |  | self,
|  |  | angle )

## ◆ setEmitterDiscOuterVelocity()

setEmitterDiscOuterVelocity | ( |  | self,
|  |  | velocity )

## ◆ setEmitterDiscRadius()

setEmitterDiscRadius | ( |  | self,
|  |  | radius )

## ◆ setEmitterExplicitLaunchVector()

setEmitterExplicitLaunchVector | ( |  | self,
|  |  | vec )

## ◆ setEmitterLinePoint1()

setEmitterLinePoint1 | ( |  | self,
|  |  | point )

## ◆ setEmitterLinePoint2()

setEmitterLinePoint2 | ( |  | self,
|  |  | point )

## ◆ setEmitterOffsetForce()

setEmitterOffsetForce | ( |  | self,
|  |  | vec )

## ◆ setEmitterPointPosition()

setEmitterPointPosition | ( |  | self,
|  |  | pos )

## ◆ setEmitterRadiateOrigin()

setEmitterRadiateOrigin | ( |  | self,
|  |  | origin )

## ◆ setEmitterRectanglePoint1()

setEmitterRectanglePoint1 | ( |  | self,
|  |  | point )

## ◆ setEmitterRectanglePoint2()

setEmitterRectanglePoint2 | ( |  | self,
|  |  | point )

## ◆ setEmitterRingLaunchAngle()

setEmitterRingLaunchAngle | ( |  | self,
|  |  | angle )

## ◆ setEmitterRingRadius()

setEmitterRingRadius | ( |  | self,
|  |  | radius )

## ◆ setEmitterRingRadiusSpread()

setEmitterRingRadiusSpread | ( |  | self,
|  |  | radiusSpread )

## ◆ setEmitterSphereSurfaceRadius()

setEmitterSphereSurfaceRadius | ( |  | self,
|  |  | radius )

## ◆ setEmitterSphereVolumeRadius()

setEmitterSphereVolumeRadius | ( |  | self,
|  |  | radius )

## ◆ setEmitterTangentRingRadius()

setEmitterTangentRingRadius | ( |  | self,
|  |  | radius )

## ◆ setEmitterTangentRingRadiusSpread()

setEmitterTangentRingRadiusSpread | ( |  | self,
|  |  | radiusSpread )

## ◆ setFactoryLifeSpan()

setFactoryLifeSpan | ( |  | self,
|  |  | value )

## ◆ setFactoryLifeSpanSpread()

setFactoryLifeSpanSpread | ( |  | self,
|  |  | value )

## ◆ setFactoryParticleMass()

setFactoryParticleMass | ( |  | self,
|  |  | value )

## ◆ setFactoryParticleMassSpread()

setFactoryParticleMassSpread | ( |  | self,
|  |  | value )

## ◆ setFactoryTerminalVelocity()

setFactoryTerminalVelocity | ( |  | self,
|  |  | value )

## ◆ setFactoryTerminalVelocitySpread()

setFactoryTerminalVelocitySpread | ( |  | self,
|  |  | value )

## ◆ setFactoryZSpinAngularVelocity()

setFactoryZSpinAngularVelocity | ( |  | self,
|  |  | vel )

## ◆ setFactoryZSpinAngularVelocitySpread()

setFactoryZSpinAngularVelocitySpread | ( |  | self,
|  |  | spread )

## ◆ setFactoryZSpinFinalAngle()

setFactoryZSpinFinalAngle | ( |  | self,
|  |  | angle )

## ◆ setFactoryZSpinFinalAngleSpread()

setFactoryZSpinFinalAngleSpread | ( |  | self,
|  |  | spread )

## ◆ setFactoryZSpinInitialAngle()

setFactoryZSpinInitialAngle | ( |  | self,
|  |  | angle )

## ◆ setFactoryZSpinInitialAngleSpread()

setFactoryZSpinInitialAngleSpread | ( |  | self,
|  |  | spread )

## ◆ setRendererAlphaMode()

setRendererAlphaMode | ( |  | self,
|  |  | alphaMode )

## ◆ setRendererColorBlendAttrib()

setRendererColorBlendAttrib | ( |  | self,
|  |  | rendererName,
|  |  | blendMethodStr,
|  |  | incomingOperandStr,
|  |  | fbufferOperandStr )

## ◆ setRendererGeomColorBlendFbufferOperand()

setRendererGeomColorBlendFbufferOperand | ( |  | self,
|  |  | operand )

## ◆ setRendererGeomColorBlendIncomingOperand()

setRendererGeomColorBlendIncomingOperand | ( |  | self,
|  |  | operand )

## ◆ setRendererGeomColorBlendMethod()

setRendererGeomColorBlendMethod | ( |  | self,
|  |  | blendMethod )

## ◆ setRendererGeomFinalXScale()

setRendererGeomFinalXScale | ( |  | self,
|  |  | xScale )

## ◆ setRendererGeomFinalYScale()

setRendererGeomFinalYScale | ( |  | self,
|  |  | yScale )

## ◆ setRendererGeomFinalZScale()

setRendererGeomFinalZScale | ( |  | self,
|  |  | zScale )

## ◆ setRendererGeomInitialXScale()

setRendererGeomInitialXScale | ( |  | self,
|  |  | xScale )

## ◆ setRendererGeomInitialYScale()

setRendererGeomInitialYScale | ( |  | self,
|  |  | yScale )

## ◆ setRendererGeomInitialZScale()

setRendererGeomInitialZScale | ( |  | self,
|  |  | zScale )

## ◆ setRendererGeomNode()

setRendererGeomNode | ( |  | self,
|  |  | event )

## ◆ setRendererLineHeadColor()

setRendererLineHeadColor | ( |  | self,
|  |  | color )

## ◆ setRendererLineScaleFactor()

setRendererLineScaleFactor | ( |  | self,
|  |  | sf )

## ◆ setRendererLineTailColor()

setRendererLineTailColor | ( |  | self,
|  |  | color )

## ◆ setRendererPointEndColor()

setRendererPointEndColor | ( |  | self,
|  |  | color )

## ◆ setRendererPointSize()

setRendererPointSize | ( |  | self,
|  |  | size )

## ◆ setRendererPointStartColor()

setRendererPointStartColor | ( |  | self,
|  |  | color )

## ◆ setRendererSparkleBirthRadius()

setRendererSparkleBirthRadius | ( |  | self,
|  |  | radius )

## ◆ setRendererSparkleCenterColor()

setRendererSparkleCenterColor | ( |  | self,
|  |  | color )

## ◆ setRendererSparkleDeathRadius()

setRendererSparkleDeathRadius | ( |  | self,
|  |  | radius )

## ◆ setRendererSparkleEdgeColor()

setRendererSparkleEdgeColor | ( |  | self,
|  |  | color )

## ◆ setRendererSparkleLifeScale()

setRendererSparkleLifeScale | ( |  | self,
|  |  | lifeScaleMethod )

## ◆ setRendererSpriteAnimationEnable()

setRendererSpriteAnimationEnable | ( |  | self | ) |

## ◆ setRendererSpriteAnimationFrameRate()

setRendererSpriteAnimationFrameRate | ( |  | self,
|  |  | rate )

## ◆ setRendererSpriteBlendMethod()

setRendererSpriteBlendMethod | ( |  | self,
|  |  | blendMethod )

## ◆ setRendererSpriteColorBlendFbufferOperand()

setRendererSpriteColorBlendFbufferOperand | ( |  | self,
|  |  | operand )

## ◆ setRendererSpriteColorBlendIncomingOperand()

setRendererSpriteColorBlendIncomingOperand | ( |  | self,
|  |  | operand )

## ◆ setRendererSpriteColorBlendMethod()

setRendererSpriteColorBlendMethod | ( |  | self,
|  |  | blendMethod )

## ◆ setRendererSpriteFinalXScale()

setRendererSpriteFinalXScale | ( |  | self,
|  |  | xScale )

## ◆ setRendererSpriteFinalYScale()

setRendererSpriteFinalYScale | ( |  | self,
|  |  | yScale )

## ◆ setRendererSpriteInitialXScale()

setRendererSpriteInitialXScale | ( |  | self,
|  |  | xScale )

## ◆ setRendererSpriteInitialYScale()

setRendererSpriteInitialYScale | ( |  | self,
|  |  | yScale )

## ◆ setRendererSpriteNonAnimatedTheta()

setRendererSpriteNonAnimatedTheta | ( |  | self,
|  |  | theta )

## ◆ setRendererUserAlpha()

setRendererUserAlpha | ( |  | self,
|  |  | alpha )

## ◆ setSpriteSourceType()

setSpriteSourceType | ( |  | self | ) |

## ◆ setSystemBirthRate()

setSystemBirthRate | ( |  | self,
|  |  | value )

## ◆ setSystemHpr()

setSystemHpr | ( |  | self,
|  |  | pos )

## ◆ setSystemLifespan()

setSystemLifespan | ( |  | self,
|  |  | value )

## ◆ setSystemLitterSize()

setSystemLitterSize | ( |  | self,
|  |  | value )

## ◆ setSystemLitterSpread()

setSystemLitterSpread | ( |  | self,
|  |  | value )

## ◆ setSystemPoolSize()

setSystemPoolSize | ( |  | self,
|  |  | value )

## ◆ setSystemPos()

setSystemPos | ( |  | self,
|  |  | pos )

## ◆ toggleAngularVelocity()

toggleAngularVelocity | ( |  | self | ) |

## ◆ toggleEffect()

toggleEffect | ( |  | self,
|  |  | effect,
|  |  | var )

## ◆ toggleEmitterDiscCubicLerping()

toggleEmitterDiscCubicLerping | ( |  | self | ) |

## ◆ toggleForce()

toggleForce | ( |  | self,
|  |  | force,
|  |  | pageName,
|  |  | variableName )

## ◆ toggleForceGroup()

toggleForceGroup | ( |  | self,
|  |  | forceGroup,
|  |  | var )

## ◆ toggleParticleEffect()

toggleParticleEffect | ( |  | self | ) |

## ◆ toggleParticleMgr()

toggleParticleMgr | ( |  | self | ) |

PARTICLE EFFECTS COMMANDS ###.

## ◆ toggleParticles()

toggleParticles | ( |  | self,
|  |  | particles,
|  |  | var )

## ◆ toggleRendererGeomXScale()

toggleRendererGeomXScale | ( |  | self | ) |

## ◆ toggleRendererGeomYScale()

toggleRendererGeomYScale | ( |  | self | ) |

## ◆ toggleRendererGeomZScale()

toggleRendererGeomZScale | ( |  | self | ) |

## ◆ toggleRendererSpriteAlphaDisable()

toggleRendererSpriteAlphaDisable | ( |  | self | ) |

## ◆ toggleRendererSpriteAnimAngle()

toggleRendererSpriteAnimAngle | ( |  | self | ) |

## ◆ toggleRendererSpriteXScale()

toggleRendererSpriteXScale | ( |  | self | ) |

## ◆ toggleRendererSpriteYScale()

toggleRendererSpriteYScale | ( |  | self | ) |

## ◆ toggleSystemGrowsOlder()

toggleSystemGrowsOlder | ( |  | self | ) |

## ◆ toggleSystemLocalVelocity()

toggleSystemLocalVelocity | ( |  | self | ) |

## ◆ updateEffectsMenus()

updateEffectsMenus | ( |  | self | ) |

## ◆ updateEmitterWidgets()

updateEmitterWidgets | ( |  | self | ) |

## ◆ updateFactoryWidgets()

updateFactoryWidgets | ( |  | self | ) |

## ◆ updateForceGroupMenus()

updateForceGroupMenus | ( |  | self | ) |

## ◆ updateForceWidgets()

updateForceWidgets | ( |  | self | ) |

FORCEGROUP COMMANDS ##.

## ◆ updateInfo()

updateInfo | ( |  | self,
|  |  | page = 'System' )

PARTICLE SYSTEM COMMANDS ###.

## ◆ updateLabels()

updateLabels | ( |  | self | ) |

## ◆ updateMenus()

updateMenus | ( |  | self | ) |

## ◆ updateMenusAndLabels()

updateMenusAndLabels | ( |  | self | ) |

## ◆ updateParticlesMenus()

updateParticlesMenus | ( |  | self | ) |

## ◆ updateRendererWidgets()

updateRendererWidgets | ( |  | self | ) |

## ◆ updateSystemWidgets()

updateSystemWidgets | ( |  | self | ) |

SYSTEM PAGE ##.

## ◆ writeSpriteRendererAnimations()

writeSpriteRendererAnimations | ( |  | self | ) |

## Member Data Documentation

## ◆ activebackground

activebackground
| static

## ◆ addForceButton

addForceButton
| static

FORCE PAGE WIDGETS ##.

## ◆ addSegmentButton

addSegmentButton
| static

Initial value:
= Menubutton(p, text = 'Add Segment',
relief = RAISED,
borderwidth = 2,
font=('MSSansSerif', 14, 'bold'),
activebackground = '#909090')

## ◆ bbp

bbp = Frame(bp)
| static

## ◆ borderwidth

borderwidth
| static

## ◆ BOTH

BOTH
| static

## ◆ bp

bp = Frame(p)
| static

## ◆ command

command
| static

## ◆ effectsDict

dict effectsDict = pe

## ◆ effectsEnableMenu

effectsEnableMenu = Menu(self.effectsLabelMenu, tearoff = 0)

## ◆ effectsLabel

effectsLabel

Initial value:
= Menubutton(labelFrame, width = 10,
relief = RAISED,
borderwidth = 2,
font=('MSSansSerif', 12, 'bold'),
activebackground = '#909090')

## ◆ effectsLabelMenu

effectsLabelMenu = Menu(self.effectsLabel, tearoff = 0)

## ◆ emissionType

emissionType = IntVar()

EMITTER PAGE WIDGETS ##.

## ◆ emitterNotebook

emitterNotebook = Pmw.NoteBook(emitterPage, tabpos = None)

## ◆ expand

expand
| static

## ◆ factoryNotebook

factoryNotebook = Pmw.NoteBook(factoryPage, tabpos = None)

## ◆ fill

fill
| static

## ◆ font

font
| static

## ◆ forceFrame

forceFrame
| static

## ◆ forceGroup

forceGroup = forceGroupList[0]

## ◆ forceGroupEnableMenu

forceGroupEnableMenu = Menu(self.forceGroupLabelMenu, tearoff = 0)

## ◆ forceGroupLabel

forceGroupLabel

Initial value:
= Menubutton(labelFrame, width = 10,
relief = RAISED,
borderwidth = 2,
font=('MSSansSerif', 12, 'bold'),
activebackground = '#909090')

## ◆ forceGroupLabelMenu

forceGroupLabelMenu = Menu(self.forceGroupLabel, tearoff = 0)

## ◆ forceGroupNotebook

forceGroupNotebook
| static

## ◆ forceMenu

forceMenu = Menu(self.addForceButton)
| static

## ◆ forcePage

forcePage
| static

## ◆ forcePageName

forcePageName

Initial value:
= (self.particleEffect.getName() + '-' +
self.forceGroup.getName())

## ◆ forcePagesDict

dict forcePagesDict = {}

## ◆ horizflex

horizflex
| static

## ◆ label

label
| static

## ◆ mainNotebook

mainNotebook = Pmw.NoteBook(interior)

## ◆ p

p = Frame(rendererSpriteTexturePage)
| static

## ◆ particleEffect

particleEffect = particleEffect

## ◆ particleMgrActive

particleMgrActive = IntVar()

## ◆ particles

particles = self.particleEffect.getParticlesList()[0]

## ◆ particlesEnableMenu

particlesEnableMenu = Menu(self.particlesLabelMenu, tearoff = 0)

## ◆ particlesLabel

particlesLabel

Initial value:
= Menubutton(labelFrame, width = 10,
relief = RAISED,
borderwidth = 2,
font=('MSSansSerif', 12, 'bold'),
activebackground = '#909090')

## ◆ particlesLabelMenu

particlesLabelMenu = Menu(self.particlesLabel, tearoff = 0)

## ◆ pp

pp = Frame(p)
| static

## ◆ relief

relief
| static

## ◆ rendererGeomNode

rendererGeomNode = StringVar()

## ◆ rendererGeomNodeEntry

rendererGeomNodeEntry

Initial value:
= Entry(f, width = 12,
textvariable = self.rendererGeomNode)

## ◆ rendererGeomSegmentFrame

rendererGeomSegmentFrame = sf.interior()

## ◆ rendererNotebook

rendererNotebook = Pmw.NoteBook(rendererPage, tabpos = None)

## ◆ rendererPointSelectBlendMethod

rendererPointSelectBlendMethod

## ◆ rendererPointSelectBlendType

rendererPointSelectBlendType = self.setRendererPointEndColor)

## ◆ rendererSegmentWidgetList

list rendererSegmentWidgetList
| static

## ◆ rendererSpriteAnimationFrame

rendererSpriteAnimationFrame
| static

## ◆ rendererSpriteAnimationWidgetList

rendererSpriteAnimationWidgetList
| static

## ◆ rendererSpriteFile

rendererSpriteFile
| static

## ◆ rendererSpriteNode

rendererSpriteNode
| static

## ◆ rendererSpriteSegmentFrame

rendererSpriteSegmentFrame
| static

## ◆ rendererSpriteTexture

rendererSpriteTexture
| static

## ◆ ringCustomFrame

ringCustomFrame = Frame(ringPage)

## ◆ segmentMenu

segmentMenu = Menu(addSegmentButton)
| static

## ◆ selectEmitterType

selectEmitterType = BOTH)

EMITTER PAGE WIDGETS ##.

## ◆ selectFactoryType

selectFactoryType

Initial value:
= self.createVector3Entry(systemPage, 'System', 'Hpr',
'Particle system orientation',
fGroup_labels = ('H', 'P', 'R'),
command = self.setSystemHpr)

FACTORY PAGE WIDGETS ##.

## ◆ selectRendererType

selectRendererType = X)

RENDERER PAGE WIDGETS ##.

## ◆ setEmissionType

setEmissionType

## ◆ setRendererAlphaMode

setRendererAlphaMode

RENDERER PAGE WIDGETS ##.

## ◆ setRendererGeomColorBlendFbufferOperand

setRendererGeomColorBlendFbufferOperand

## ◆ setRendererGeomColorBlendIncomingOperand

setRendererGeomColorBlendIncomingOperand

## ◆ setRendererGeomColorBlendMethod

setRendererGeomColorBlendMethod = X)

## ◆ setRendererGeomNode

setRendererGeomNode

## ◆ setRendererSparkleLifeScale

setRendererSparkleLifeScale = self.setRendererSparkleDeathRadius)

## ◆ sf

sf = Pmw.ScrolledFrame(pp, horizflex = 'elastic')
| static

## ◆ side

side
| static

## ◆ tabpos

tabpos
| static

## ◆ text

text
| static

## ◆ toggleAngularVelocity

toggleAngularVelocity = self.factoryNotebook.add('ZSpinParticleFactory')

## ◆ toggleEmitterDiscCubicLerping

toggleEmitterDiscCubicLerping = self.setEmitterDiscOuterVelocity)

## ◆ toggleRendererGeomXScale

toggleRendererGeomXScale = X)

## ◆ toggleRendererGeomYScale

toggleRendererGeomYScale = LEFT)

## ◆ toggleRendererGeomZScale

toggleRendererGeomZScale = LEFT)

## ◆ toggleSystemGrowsOlder

toggleSystemGrowsOlder

## ◆ toggleSystemLocalVelocity

toggleSystemLocalVelocity

Initial value:
= (
('System', 'Pool Size',
'Max number of simultaneous particles',
self.setSystemPoolSize,
1.0, 2000000, 1.0),
('System', 'Birth Rate',
'Seconds between particle births',
self.setSystemBirthRate,
0.0, None, None),
('System', 'Litter Size',
'Number of particle created at each birth',
self.setSystemLitterSize,
1.0, 0x7fffffff, 1.0),
('System', 'Litter Spread',
'Variation in litter size',
self.setSystemLitterSpread,
0.0, 0x7fffffff, 1.0),
('System', 'Lifespan',
'Age in seconds at which the system (vs. particles) should die',
self.setSystemLifespan,
0.0, None, None)
)